/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2023  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BEN_STRLIST_H
#define BEN_STRLIST_H
#include "array.h"
#include "buffer.h"

typedef struct array_t strlist;

void strlist_init(strlist *a);
void strlist_clear(strlist *a);
void strlist_reset(strlist *a);

char **strlist_get(strlist *a, size_t n);
char **strlist_data(strlist *a);
void strlist_append(strlist *a, char **l, size_t n);
void strlist_append_one(strlist *a, char *str);

// note: strlist_parse() overwrites its argument string str.
void strlist_parse(strlist *a, char *str);




#endif

